#include "SmartCard.h"

#define DEBUG_
#define DEBUG1

UINT hHandle;
DWORD CurrentStatus;
DWORD pdwProto;
BYTE Atr[64];
UINT AtrLen = 64;
BYTE Pts[64];
UINT PtsLen = 64;
BYTE SW1, SW2;
char name[32];
char port[32];
BYTE type;
int nbr;

const char HexaNum[16] = {'0','1','2','3','4','5','6','7','8','9', 'A','B','C','D','E','F'};

/*
BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
    return TRUE;
}
*/

/* transforms ASCII string into bytes */
BOOL AsciiToBinary(const char *str, BYTE *str2)
{
    int NbrChar = strlen(str);
    UINT uiRest = (NbrChar&01);
    int i, j;
    int IndiceBuff = 0 ;
    BYTE ValLast = 0 ;

    for (i = 0; i < NbrChar; i++) {
	BYTE Val = 0xFF ;
	for (j=0; j<16; j++ ) {
	    if ( HexaNum[j]==str[i] ) {
		Val = (BYTE)j ;
		break ;
	    }
	}

	if (Val==0xFF) return FALSE;

	if ( ((!uiRest) && (i&01)) || ( !(i&01) && (uiRest == 1)) ) /* LSB */
	    str2[IndiceBuff++] = ValLast | Val;
	else    /* MSB */
	    ValLast = Val<<4 ;
    }
    return TRUE;
}

/* transforms binary code to ASCII string */
int BinaryToAscii(char *strBin, char *StrAscii, int size)
{
    int len, i;
    BYTE b0, b1;

    len = size;
    fprintf(stderr, "-----> The binary string length is %d\n", size);

    for ( i = 0; i < len ; i++ ) {
	b0 = *(strBin+i);
	b1 = b0 >> 4;
	b0 = b0 & 0x0F;
	*(StrAscii+2*i) =  HexaNum[(int)b1];
	*(StrAscii+2*i+1) = HexaNum[(int)b0];
    }
    *(StrAscii+2*i) = 0x00;

    return strlen(StrAscii);
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIAllocate
    (JNIEnv * env, jobject obj) {
    /* Allocates the reader */
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIAllocate is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIAllocate(ReaderType, Port, &hHandle, &CurrentStatus);
    
    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIState
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIState is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIState(hHandle, &CurrentStatus, &pdwProto, Atr, &AtrLen);

    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPISetCode
    (JNIEnv * env, jobject obj, jint wCode) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPISetCode is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPISetCode(hHandle, (WORD) wCode, &CurrentStatus);

    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIMonitor
    (JNIEnv * env, jobject obj, jint type) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIMonitor is called\n");
    fflush(stderr);
#endif

    switch ((int) type) {
    case INSERTION:
	if (CurrentStatus==SLBAPI_UNAVAILABLE || CurrentStatus==SLBAPI_SYSTEMERROR) {
	    /*
	    int rc;
	    Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIAllocateComManager(env, obj);
	    Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIGetReaderName(env, obj);
	    Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIFreeComManager(env, obj);
	    rc = (int) Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIAllocate(env, obj);
	    */
#ifdef DEBUG
	    fprintf(stderr, "Reader could not be allocated\n");
	    fflush(stderr);
#endif
	    return NOCARDREADER;
	}

#ifdef DEBUG
	fprintf(stderr, "Waiting for card insertion\n");
	fflush(stderr);
#endif

	while (CurrentStatus==SLBAPI_CARDABSENT) {
	    iResult = SLBAPIMonitor(hHandle, SLBAPI_CARDABSENT, &CurrentStatus);
	    if (iResult != SLBAPI_OK)
		iResult = SLBAPICancel(hHandle, &CurrentStatus);
	}

#ifdef DEBUG
	fprintf(stderr, "Card is inserted\n");
	fflush(stderr);
#endif

	switch (iResult) {
	    /*    case SLBAPI_OK: return AUTHSUCCESS;*/
	case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
	case SLBAPI_ABORTED: return AUTHABORT;
	case SLBAPI_ERROR: return AUTHERROR;
	default: return AUTHSUCCESS;
	}
	break;
    case REMOVAL:
	if (CurrentStatus==SLBAPI_UNAVAILABLE) {
#ifdef DEBUG
	    fprintf(stderr, "Reader could not be allocated\n");
	    fflush(stderr);
#endif
	    return NOCARDREADER;
	}

#ifdef DEBUG
	fprintf(stderr, "Waiting for card removal\n");
	fflush(stderr);
#endif

	while (CurrentStatus!=SLBAPI_CARDABSENT && CurrentStatus!=SLBAPI_SYSTEMERROR) {
	    iResult = SLBAPIMonitor(hHandle, CurrentStatus, &CurrentStatus);
	    if (iResult != SLBAPI_OK)
		iResult = SLBAPICancel(hHandle, &CurrentStatus);
	}

#ifdef DEBUG
	fprintf(stderr, "Card is removed\n");
	fflush(stderr);
#endif

	switch (iResult) {
	    /*    case SLBAPI_OK: return AUTHSUCCESS;*/
	case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
	case SLBAPI_ABORTED: return AUTHABORT;
	case SLBAPI_ERROR: return AUTHERROR;
	default: return AUTHSUCCESS;
	}
	break;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPICancel
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPICancel is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPICancel(hHandle, &CurrentStatus);

    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIPowerUp
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIPowerUp is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIPowerUp(hHandle, &CurrentStatus);

    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIPowerDown
    (JNIEnv * env, jobject obj) {
    int iResult=SLBAPI_OK;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIPowerDown is called\n");
    fflush(stderr);
#endif

    if (CurrentStatus != SLBAPI_CARDABSENT)
	iResult = SLBAPIPowerDown(hHandle, &CurrentStatus);

    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIReset
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIReset is called\n");
    fflush(stderr);
#endif

    if (CurrentStatus==SLBAPI_CARDSWALLOWED) {
#ifdef DEBUG
    fprintf(stderr, "Power up the card reader\n");
    fflush(stderr);
#endif
	iResult = SLBAPIPowerUp(hHandle, &CurrentStatus);
    }
    else {
#ifdef DEBUG
    fprintf(stderr, "Reset the card reader\n");
    fflush(stderr);
#endif
	iResult = SLBAPIReset(hHandle, &CurrentStatus, Atr, &AtrLen);
    }

#ifdef DEBUG
    fprintf(stderr, "Done resetting the card reader, obtaining the state ...\n");
    fflush(stderr);
#endif

    iResult = SLBAPIState(hHandle, &CurrentStatus, &pdwProto, Atr, &AtrLen);

    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

int AuthSLBAPISendPTS() {
  int iResult;

#ifdef DEBUG
  fprintf(stderr, "AuthSLBAPISendPTS is called\n");
  fflush(stderr);
#endif

  iResult = SLBAPISendPTS(hHandle, &CurrentStatus, Pts, &PtsLen);

  switch (iResult) {
      /*  case SLBAPI_OK: return AUTHSUCCESS;*/
  case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
  case SLBAPI_ABORTED: return AUTHABORT;
  case SLBAPI_ERROR: return AUTHERROR;
  default: return AUTHSUCCESS;
  }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPISendIsoInT0
    (JNIEnv * env, jobject obj, jstring ca) {
#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPISendIsoInT0 is called\n");
    fflush(stderr);
#endif
    if (CurrentStatus==SLBAPI_NEGOTIABLEMODE ||
	CurrentStatus==SLBAPI_SPECIFICMODE) {
	jboolean isCopy;
	const char *DataTmp=(*env)->GetStringUTFChars(env, ca, &isCopy);
	int Size=((int)(*env)->GetStringUTFLength(env, ca))/2;
	char *Data = (char *)malloc(((int) (*env)->GetStringUTFLength(env, ca)+1)*sizeof(char));
	int iResult;

	AsciiToBinary(DataTmp, Data);
	BinaryToAscii((char *)Data, (char *)DataTmp, Size);

#ifdef DEBUG
	fprintf(stderr, "The data size is %d\n", Size);
	fprintf(stderr, "The data is <<%s>>\n", DataTmp);
	fprintf(stderr, "The binary data is <<%s>>\n", Data);
	fflush(stderr);
#endif

	iResult = SLBAPISendIsoInT0(hHandle,
				    (const LPBYTE) Data,
				    (UINT) Size,
				    &CurrentStatus,
				    &SW1,
				    &SW2);
	
#ifdef DEBUG
	fprintf(stderr, "The card status = %02X%02X\n", SW1, SW2);
	fflush(stderr);
#endif

	(*env)->ReleaseStringUTFChars(env, ca, DataTmp);
	free(Data);

	switch (iResult) {
	    /*	case SLBAPI_OK: return AUTHSUCCESS;*/
	case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
	case SLBAPI_ABORTED: return AUTHABORT;
	case SLBAPI_ERROR: return AUTHERROR;
	default: return AUTHSUCCESS;
	}
    }

    return WRONGSTATE;
}

JNIEXPORT jstring JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPISendIsoOutT0
    (JNIEnv * env, jobject obj, jstring ca1) {
    char Answer[512], AnswerTmp[256];
    jstring ca2;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPISendIsoOutT0 is called\n");
    fflush(stderr);
#endif
    if (CurrentStatus==SLBAPI_NEGOTIABLEMODE ||
	CurrentStatus==SLBAPI_SPECIFICMODE) {
	jboolean isCopy;
	const char *DataTmp=(*env)->GetStringUTFChars(env, ca1, &isCopy);
	UINT AnswerSize=128;
	int Size=((int) (*env)->GetStringUTFLength(env, ca1))/2;
	char *Data = (char *)malloc(((int) (*env)->GetStringUTFLength(env, ca1)+1)*sizeof(char));
	int iResult;

	AsciiToBinary(DataTmp, Data);

#ifdef DEBUG
	fprintf(stderr, "The data size is %d\n", Size);
	fprintf(stderr, "The data is <<%s>>\n", DataTmp);
	fprintf(stderr, "The binary data is <<%s>>\n", Data);
	fflush(stderr);
#endif

	iResult = SLBAPISendIsoOutT0(hHandle,
				     (const LPBYTE) Data,
				     (UINT) Size,
				     &CurrentStatus,
				     (LPBYTE) AnswerTmp,
				     &AnswerSize,
				     &SW1,
				     &SW2);

	AnswerTmp[AnswerSize]=0;

	BinaryToAscii(AnswerTmp, Answer, AnswerSize);

#ifdef DEBUG
	fprintf(stderr, "Answer is <<%s>>\n", Answer);
	fprintf(stderr, "The card status = %02X%02X\n", SW1, SW2);
	fflush(stderr);
#endif

	switch (iResult) {
	case SLBAPI_TIMEOUT:
	case SLBAPI_ABORTED:
	case SLBAPI_ERROR:
	    sprintf(Answer, "ERROR: %d", iResult);
	default:
	    break;
	}

	ca2=(*env)->NewStringUTF(env, Answer);
	(*env)->ReleaseStringUTFChars(env, ca1, DataTmp);
	free(Data);
	return ca2;
    }

    sprintf(Answer, "ERROR: %d", WRONGSTATE);
    ca2=(*env)->NewStringUTF(env, Answer);
    return ca2;
}

JNIEXPORT jstring JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPISendT1
    (JNIEnv * env, jobject obj, jstring ca1) {
    char Answer[512], AnswerTmp[256];
    jstring ca2;
#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPISendT1 is called\n");
    fflush(stderr);
#endif
    if (CurrentStatus==SLBAPI_NEGOTIABLEMODE ||
	CurrentStatus==SLBAPI_SPECIFICMODE) {
	jboolean isCopy;
	const char *DataTmp=(*env)->GetStringUTFChars(env, ca1, &isCopy);
	UINT AnswerSize=128;
	int Size=((int) (*env)->GetStringUTFLength(env, ca1))/2;
	char *Data = (char *)malloc(((int) (*env)->GetStringUTFLength(env, ca1)+1)*sizeof(char));
	int iResult;

	AsciiToBinary(DataTmp, Data);

#ifdef DEBUG
	fprintf(stderr, "The data size is %d\n", Size);
	fprintf(stderr, "The data is <<%s>>\n", DataTmp);
	fprintf(stderr, "The binary data is <<%s>>\n", Data);
	fflush(stderr);
#endif

	iResult = SLBAPISendT1(hHandle,
				   (const LPBYTE) Data,
				   (UINT) Size,
				   &CurrentStatus,
				   (LPBYTE) Answer,
				   &AnswerSize,
				   &SW1,
				   &SW2);

	BinaryToAscii(AnswerTmp, Answer, AnswerSize);

#ifdef DEBUG
	fprintf(stderr, "Answer is <<%s>>\n", Answer);
	fprintf(stderr, "The card status = %02X%02X\n", SW1, SW2);
	fflush(stderr);
#endif

	switch (iResult) {
	case SLBAPI_TIMEOUT:
	case SLBAPI_ABORTED:
	case SLBAPI_ERROR:
	    sprintf(Answer, "ERROR: %d", iResult);
	default:
	    break;
	}

	ca2=(*env)->NewStringUTF(env, Answer);
	(*env)->ReleaseStringUTFChars(env, ca1, DataTmp);
	free(Data);
	return ca2;
    }

    sprintf(Answer, "ERROR: %d", WRONGSTATE);
    ca2=(*env)->NewStringUTF(env, Answer);
    return ca2;
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIFree
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIFree is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIFree(hHandle, &CurrentStatus);

    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIGetAllocatedReader
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIGetAllocatedReader is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIGetAllocatedReader(hHandle, name, 32, port, 32, &CurrentStatus);

#ifdef DEBUG
    fprintf(stderr, "The card name is %s, it is on port %s\n", name, port);
    fflush(stderr);
#endif

    if (strcmp(name, ReaderType))		/* The card name is not "REFLEX60" */
	return WRONGCARDTYPE;

    if (strcmp(port, Port))		/* The card port is not "COM2" */
	return WRONGPORT;

    switch (iResult) {
	/*    case SLBAPI_OK: return AUTHSUCCESS;*/
    case SLBAPI_TIMEOUT: return AUTHTIMEOUT;
    case SLBAPI_ABORTED: return AUTHABORT;
    case SLBAPI_ERROR: return AUTHERROR;
    default: return AUTHSUCCESS;
    }
}

int AuthSLBAPICallExtendedFunction() {
#ifdef DEBUG
  fprintf(stderr, "AuthSLBAPICallExtendedFunction is called\n");
  fflush(stderr);
#endif

  return NOTSUPPORTED;
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIAllocateComManager
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIAllocateComManager is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIAllocateComManager();

    switch (iResult) {
    case TRUE: return AUTHTRUE;
    case FALSE: return AUTHFALSE;
    default: return AUTHUNKNOWN;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIFreeComManager
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIFreeComManager is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIFreeComManager();

    switch (iResult) {
    case TRUE: return AUTHTRUE;
    case FALSE: return AUTHFALSE;
    default: return AUTHUNKNOWN;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIGetNbrReaders
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIGetNbrReaders is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIGetNbrReaders();

    switch (iResult) {
    case TRUE: return AUTHTRUE;
    case FALSE: return AUTHFALSE;
    default: return AUTHUNKNOWN;
    }
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIGetNbrFreePorts
    (JNIEnv * env, jobject obj) {
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIGetNbrFreePorts is called\n");
    fflush(stderr);
#endif

    iResult = SLBAPIGetNbrFreePorts();

    return (jint) iResult;
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIGetReaderName
    (JNIEnv * env, jobject obj) {
    UINT i = 0;
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIGetReaderName is called\n");
    fflush(stderr);
#endif

    nbr=Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIGetNbrFreePorts(env, obj);

    for (i=0; i<nbr; i++) {
	iResult = SLBAPIGetReaderName(i, name, 32, &type);

#ifdef DEBUG
	fprintf(stderr, "The card name is %s\n", name);
	fflush(stderr);
#endif
	/*
	if (strcmp(name, ReaderType)==0)
	    return WRONGCARDTYPE;
	*/
	switch (iResult) {
	case TRUE: return (jint) i;
	}
    }

    return ERROR;
}

JNIEXPORT jint JNICALL Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIGetFreePort
    (JNIEnv * env, jobject obj) {
    UINT i;
    int iResult;

#ifdef DEBUG
    fprintf(stderr, "AuthSLBAPIGetFreePort is called\n");
    fflush(stderr);
#endif

    nbr=Java_edu_cmu_paid_authentication_SmartCard_SmartCard_AuthSLBAPIGetNbrFreePorts(env, obj);

    for (i=0; i<nbr; i++) {
	iResult = SLBAPIGetFreePort(i, port, 32, &type);
	/*
	if (strcmp(port, Port))
	    return WRONGPORT;
	*/
	switch (iResult) {
	case TRUE: return (jint) i;
	}
    }

    return ERROR;
}

int AuthInfoVersion() {
#ifdef DEBUG
  fprintf(stderr, "AuthInfoVersion is called\n");
  fflush(stderr);
#endif

  return NOTSUPPORTED;
}
